//+------------------------------------------------------------------+
//|                                              saDonchianKijun.mq4 |
//|                                                          Jeex.Eu |
//|                                             http://forexninja.nl |
//+------------------------------------------------------------------+
#property copyright "Jeex.Eu"
#property link      "http://forexninja.nl"

#property indicator_chart_window
#property indicator_buffers 8

// Kijun
#property indicator_color1 DodgerBlue
// Donchian Upper
#property indicator_color2 OrangeRed
// Donchian Lower
#property indicator_color3 OrangeRed
// Ema High
#property indicator_color4 Gold
// Ema Low
#property indicator_color5 Gold
// Donchian Slow Upper
#property indicator_color6 OrangeRed
// Donchian Slow Lower
#property indicator_color7 OrangeRed


#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1

#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID
#property indicator_style5 STYLE_SOLID
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT

//---- buffers
double dSlowUpper[];
double dSlowLower[];
double kijun[];
double dFastUpper[];
double dFastLower[];
double emaHigh[];
double emaLow[];

//--- input parameters
extern int  EmaPeriods           = 10;
extern int  DonchianSlowPeriods  = 52;
extern int  DonchianFastPeriods  = 0;
extern int  KijunSenPeriods      = 26;
int  SenkouPeriods               = 0;
int TenkanSenPeriods             = 9;
extern int  HiLoPaBars           = 6;
extern int ShowLabel             = 4;
extern int StopLossPoints        = 200;
extern int MaxRiskPromille       = 20;

double _punt;
int dezeBar = 0;

int init()
{

   for( int i = 0; i <= Bars; i++ )
   {
      if( ObjectFind("hilopa_"+i) > -1 )
         ObjectDelete("hilopa_"+i);
   }

   SetIndexBuffer(0,kijun);
   SetIndexLabel(0,"Kijun");
   SetIndexBuffer(1,dSlowUpper);
   SetIndexLabel(1,"Donchian Slow");
   SetIndexBuffer(2,dSlowLower);
   SetIndexLabel(2,"Donchian Slow");
   SetIndexBuffer(3,emaHigh);
   SetIndexLabel(3,"Ema High");
   SetIndexBuffer(4,emaLow);
   SetIndexLabel(4,"Ema Low");
   SetIndexBuffer(5,dFastUpper);
   SetIndexLabel(5,"Donchian Fast");
   SetIndexBuffer(6,dFastLower);
   SetIndexLabel(6,"Donchian Fast");
      
   if( ObjectFind("SemperAugustus_HHiLoPa") >= 0 )
      ObjectDelete("SemperAugustus_HHiLoPa");
   ObjectCreate("SemperAugustus_HHiLoPa", OBJ_LABEL, 0,0,0);
   ObjectSet("SemperAugustus_HHiLoPa", OBJPROP_CORNER, ShowLabel-1);
   ObjectSet("SemperAugustus_HHiLoPa", OBJPROP_XDISTANCE, 5);
   ObjectSet("SemperAugustus_HHiLoPa", OBJPROP_YDISTANCE, 5);
   
   _punt = NormalizeDouble(MarketInfo(Symbol(), MODE_POINT), 8);
   
   dezeBar = Bars-1;
   return(0);
}

int deinit()
{
   for( int i = 0; i <= Bars; i++ )
   {
      if( ObjectFind("hilopa_"+i) > -1 )
         ObjectDelete("hilopa_"+i);
   }
   return(0);
}


int start()
{
   double hlp;
   if( dezeBar == Bars )
   {
      if( DonchianSlowPeriods > 0 )
      {
         dSlowUpper[0] = calcDonchianUpper(0, DonchianSlowPeriods);
         dSlowLower[0] = calcDonchianLower(0, DonchianSlowPeriods);
      }
      else
      {
         dSlowUpper[0] = EMPTY_VALUE;
         dSlowLower[0] = EMPTY_VALUE;
      }
   
      if( KijunSenPeriods > 0 )
      {
         kijun[0] = calcKijun(0, Period());
      }
      else
      {
         kijun[0] = EMPTY_VALUE;
      }
   
      if( EmaPeriods > 0 )
      {
         emaHigh[0] = iMA(NULL, 0, EmaPeriods, 0, MODE_EMA, MODE_HIGH, 0);
         emaLow[0] = iMA(NULL, 0, EmaPeriods, 0, MODE_EMA, MODE_LOW, 0);
      }
      else
      {
         emaHigh[0] = EMPTY_VALUE;
         emaLow[0] = EMPTY_VALUE;
      }
   
      if( DonchianFastPeriods > 0 )
      {
         dFastUpper[0] = calcDonchianUpper(0, DonchianFastPeriods);
         dFastLower[0] = calcDonchianLower(0, DonchianFastPeriods);
      }
      else
      {
         dFastUpper[0] = EMPTY_VALUE;
         dFastLower[0] = EMPTY_VALUE;
      }
      
      if( HiLoPaBars > 0 )
      {
         hlp = isHighOrLow(0, HiLoPaBars);
         if( hlp != 0 )
               setHiLoPaDot(0, hlp);
      }
      
   }
   else
   {
      dezeBar = Bars;
      int limit;
      int counted_bars=IndicatorCounted();
   //---- check for possible errors
      if(counted_bars < 0)
         return(-1);

      if(counted_bars>0) counted_bars--;
      limit=Bars-counted_bars;
      
   //---- main loop
      for(int i=0; i<limit; i++ )
      {
         if( DonchianSlowPeriods > 0 )
         {
            dSlowUpper[i] = calcDonchianUpper(i, DonchianSlowPeriods);
            dSlowLower[i] = calcDonchianLower(i, DonchianSlowPeriods);
         }
         else
         {
            dSlowUpper[i] = EMPTY_VALUE;
            dSlowLower[i] = EMPTY_VALUE;
         }
         if( EmaPeriods > 0 )
         {
            emaHigh[i] = iMA(NULL, 0, EmaPeriods, 0, MODE_EMA, MODE_HIGH, i);
            emaLow[i] = iMA(NULL, 0, EmaPeriods, 0, MODE_EMA, MODE_LOW, i);
         }
         else
         {
            emaHigh[i] = EMPTY_VALUE;
            emaLow[i] = EMPTY_VALUE;
         }
      
         if( KijunSenPeriods > 0 )
         {
            kijun[i] = calcKijun(i, Period());
         }
         else
         {
            kijun[i] = EMPTY_VALUE;
         }
      
         if( DonchianFastPeriods > 0 )
         {
            dFastUpper[i] = calcDonchianUpper(i, DonchianFastPeriods);
            dFastLower[i] = calcDonchianLower(i, DonchianFastPeriods);
         }
         else
         {
            dFastUpper[i] = EMPTY_VALUE;
            dFastLower[i] = EMPTY_VALUE;
         }
         
         if( HiLoPaBars > 0 )
         {
            hlp = isHighOrLow(i, HiLoPaBars);
            if( hlp != 0 )
               setHiLoPaDot(i, hlp);
         }
      }
   }

   if( ShowLabel > 0 )
   {
      labelTekst(0);
   }
   return(0);
}
void setHiLoPaDot(int shift, int ri)
{
   // tekent de hilopadot
   string dotnaam = "hilopa_" + (shift+1);
   if( ObjectFind(dotnaam) > -1 )
      ObjectDelete(dotnaam);
   
   if( ri == 1 )
   {
      ObjectCreate(dotnaam, OBJ_TEXT, 0,Time[shift+1],(High[shift+1]+(10*_punt)));
      ObjectSetText(dotnaam, "l", 10, "Wingdings", Lime);
   }
   else if( ri == -1 )
   {
      ObjectCreate(dotnaam, OBJ_TEXT, 0,Time[shift+1],Low[shift+1]);
      ObjectSetText(dotnaam, "l", 10, "Wingdings", Lime);
   }
      
     
}

int isHighOrLow(int shift, int back)
{
   double top;
   int i;
   if( High[shift] < High[shift+1] && Close[shift] < Open[shift] )
   {
      // onderzoeken op Highes High van Shift+1
      top = High[shift+1];
      for( i = (shift+2); i < (shift+back+1); i++ )
      {
         if( High[i] > top )
            return( 0 );
      }
      return( 1 );      
   }
   else if( Low[shift] < Low[shift+1] && Close[shift] > Open[shift] )
   {
      // onderzoeken op Highes High van Shift+1
      top = Low[shift+1];
      for( i = (shift+2); i < (shift+back+1); i++ )
      {
         if( Low[i] < top )
            return( 0 );
      }
      return( -1 ); 
   }
   else
   {
      return( 0 );
   }
} 


double calcDonchianUpper(int shift, int per)
{
   double d = 0; 
   for( int i = 0; i < per; i++ )
   {
      d = MathMax(d, High[shift+i]);
   }
   return( d );
}
double calcDonchianLower(int shift, int per)
{
   double d = Ask * 2.0; 
   for( int i = 0; i < per; i++ )
   {
      d = MathMin(d, Low[shift+i]);
   }
   return( d );
}
double calcKijun(int shift, int per)
{
   int sp;
   if( SenkouPeriods == 0 )
      sp = 52;
   else
      sp = SenkouPeriods;
      
   return( iIchimoku(NULL, per, TenkanSenPeriods,KijunSenPeriods,sp, MODE_KIJUNSEN, shift) );
}
double calcVolumePerTrade(double koers, double sl)
{
   sl = Ask-(sl*_punt);
   double pointwaarde = NormalizeDouble(calcPointWaarde(koers), 8);
   double verschil = MathAbs(koers - sl);
   double verschilwaarde = ( pointwaarde/_punt ) * verschil;
   double risico = AccountEquity() * ( MaxRiskPromille / 1000.0 );
   double loten = (risico/verschilwaarde);
   double volume = NormalizeDouble( (loten/100000.0), 2);      
   return( volume );
}

double calcPointWaarde(double koers)
{
   // want EUR account
   // GEEFT Point-waarde in EUR's van de huidige koers
   string base = StringSubstr(Symbol(), 0, 3);
   string acc = "EUR" + base + "i";

   double basediff = (_punt/koers); 
   if( base == "EUR" )
      return( basediff );
   else
   {
      return( basediff/MarketInfo(acc, MODE_ASK) );
   }      
}
void labelTekst(int shift)
{
   int spread = MarketInfo(Symbol(), MODE_SPREAD);
   // gemiddelde breedte candles
   double gem = 0;
   for(int i = 0; i < 6; i++ )
      gem = (gem+ (High[i] - Low[i])) / (i+1);
   int breedte = MathRound( NormalizeDouble( ( gem / MarketInfo(Symbol(), MODE_POINT) ), 6) );
   // tussen Donchian Channel
   int slowbreedte = MathRound( ( ( (dSlowUpper[0]-dSlowLower[0]  ))/MarketInfo(Symbol(), MODE_POINT) ));
   // tussen Donchian Upper en Kijun Sen
   int upperBreedte = MathRound( ( ( (dSlowUpper[0]-kijun[0]  ))/MarketInfo(Symbol(), MODE_POINT) ));
   // tussen Kijun Sen en Donchian Lower
   int lowerBreedte = MathRound( ( ( (kijun[0]-dSlowLower[0]  ))/MarketInfo(Symbol(), MODE_POINT) ));
   // tijd voor nieuwe candle
   int tegaan = ( (Period()*60) - (TimeCurrent()-Time[0]) ) / 60;
   string vol = DoubleToStr( calcVolumePerTrade( Ask, StopLossPoints ), 2);
   if( ObjectFind("SemperAugustus_HHiLoPa")< 0 )
   {
      ObjectCreate("SemperAugustus_HHiLoPa", OBJ_LABEL, 0,0,0);
      ObjectSet("SemperAugustus_HHiLoPa", OBJPROP_CORNER, ShowLabel-1);
      ObjectSet("SemperAugustus_HHiLoPa", OBJPROP_XDISTANCE, 5);
      ObjectSet("SemperAugustus_HHiLoPa", OBJPROP_YDISTANCE, 5);
   }
   ObjectSetText("SemperAugustus_HHiLoPa", "BandWith(pts): "+( breedte ) + "/" + slowbreedte + "/" + upperBreedte + "/" + lowerBreedte + " Spread: " + ( spread ) + " Lot " + vol + " New candle: "+tegaan+"m", 8, "Courier New", White);

}